(********************************************************************)
(*																	*)
(*						Map Editor GUI Class						*)
(*																	*)
(********************************************************************)

unit GuiMap;

interface

uses TClass,GuiObj,GuiMenu;

type TTileTypeCombo = object(TComboBox)
	constructor Init(x,y,w,h:Integer);
	procedure   Paint;virtual;
end;

type PTileTypeCombo = ^TTileTypeCombo;

type TMapEditor = object(TGuiObject)
	Scale:Integer;
	SelEditor:PTileSelectEditor;
	TypeCombo:PTileTypeCombo;
	OType:Integer;
	Map:TMap;
	constructor Init(x,y,s:Integer;TSE:PTileSelectEditor;TTC:PTileTypeCombo);
	procedure	Paint;virtual;
	procedure	Refresh(x,y:Integer);
	procedure	Click(x,y:Integer);virtual;
end;

type PMapEditor = ^TMapEditor;

implementation

uses Graph,Video;

constructor TMapEditor.Init(x,y,s:Integer;TSE:PTileSelectEditor;TTC:PTileTypeCombo);
var x1,y1:Integer;
begin
	SelEditor := TSE;
	TypeCombo := TTC;
	Scale := s;
	for x1 := 0 to 11 do
		for y1 := 0 to 7 do
			Map[x1,y1] := Random(3)*64+Random(2)*63;
	TGuiObject.Init(x,y,s*12*8+15,s*8*8+12);
end;

procedure	TMapEditor.Paint;
var x,y:Integer;
begin
	Box3D(Left,Top,Right,Bottom,True);
	for x := 0 to 11 do
		for y := 0 to 7 do
			Refresh(x,y);
end;

procedure	TMapEditor.Refresh(x,y:Integer);
var c,n:Integer;
begin
	n := Map[x,y];
	x := x*8*Scale+2+Left+x;
	y := y*8*Scale+2+Top+y;
	case (n and $C0) of
		$00:	c := Green;
		$40:	c := Red;
		$80:	c := Yellow;
		$C0:	c := LightBlue;
	end;
    SelEditor^.TSel^.Tiles^.Tile[n and 63].Draw(x,y,Scale,c);
	if GetPixel(x+1,y+1) = Black then PutPixel(x+1,y+1,c);
	SetColor(c);if n = 0 then Line(x,y+3,x+3,y);
end;

procedure	TMapEditor.Click(x,y:Integer);
begin
	x := (x-2) div (8*Scale+1);
	y := (y-2) div (8*Scale+1);
    if x > 11 then x := 11;
	if y > 8  then y := 8;
	Map[x,y] := SelEditor^.Get;
	Map[x,y] := Map[x,y] + (TypeCombo^.Get-1)*64;
	Refresh(x,y);
end;

constructor TTileTypeCombo.Init(x,y,w,h:Integer);
begin
	TComboBox.Init(x,y,w,h,1,'Scenery:Action:Monster:Object');
end;

procedure   TTileTypeCombo.Paint;
var c:Integer;
begin
	TComboBox.Paint;
	case Get of
		1:	c := Green;
		2:	c := Red;
		3:	c := Yellow;
		4:	c := LightBlue;
	end;
	SetFillStyle(SolidFill,c);
	Bar(Right-15,Top+2,Right-3,Bottom-2);
	SetColor(Black);
	Rectangle(Right-15,Top+2,Right-3,Bottom-2);
end;

begin
end.


